-- MC8051 IP Core Demo Design, Architecture of PLL simulation model
-- Date: 2017-02-08

library IEEE; 
use IEEE.std_logic_1164.all; 
use IEEE.std_logic_unsigned."+";

architecture sim of prescaler is
       
  signal s_cnt : std_logic_vector(1 downto 0);
  signal s_clk_out1 : std_logic;

  begin

  -- Simulation model of PLL
  p_pll : process (reset, clk_in1)
  begin
    if reset = '1' then
      s_cnt <= "00";
      s_clk_out1 <= '0';
      locked <= '0';
    elsif clk_in1'event and clk_in1='1' then
      s_cnt <= s_cnt + '1';

      -- generate slower output clock (clock input divided by four)
      -- set "locked" signal to logic 1, 4 clocks after reset being deasserted
      if (s_cnt="11") then
        locked <= '1';
        s_clk_out1 <= not(s_clk_out1);
      end if;
    end if;  
  end process p_pll;

  clk_out1 <= s_clk_out1;
  
end sim;